#!/usr/bin/env sh

PYTHON_BINARY=/usr/local/bin/python
test -z "$1" || PYTHON_BINARY=$1

set -e

MY_DIR=$(cd $(dirname $(dirname $(readlink -f $0)));pwd)
cd ${MY_DIR}
git pull -v

rm -rf venv

${PYTHON_BINARY} -m venv venv

. venv/bin/activate

python -m pip install -U pip wheel setuptools

# Until https://github.com/yaml/pyyaml/pull/618/ gets merged, on FreeBSD
# install PyYAML with:

install_pip_packages() {
    C_INCLUDE_PATH=/usr/local/include/ PYYAML_FORCE_LIBYAML=1 \
    python -m pip install -e .
}

install_pip_packages || {
    pkg install -y lang/rust
    install_pip_packages
    # Removes rust bloat
    rm -rf ~/.cargo/
    pkg remove -y lang/rust
}

patch_certbot() {
    MODULES_PATH=$(python -c 'import certbot, pathlib; print(pathlib.Path(certbot.__file__).parent.parent)')
    cd "$MODULES_PATH"
    curl -O https://cgit.freebsd.org/ports/plain/security/py-certbot/files/patch-certbot-compat-misc.py
    patch -ui patch-certbot-compat-misc.py
    rm patch-certbot-compat-misc.py
    cd -
}
patch_certbot

ln -fs "${MY_DIR}/venv/bin/daneupdate" /usr/local/bin

# vim: sw=4:smarttab
