#!/usr/bin/env python3

from typing import Union

from .handlers.adopt import AdoptHandler, ListAdoptablesHandler
from .handlers.renew import RenewHandler
from .handlers.update_tlsa import UpdateTlsaHandler
from .utils.config import Configuration
from .utils.parser_setup import get_parser

_HandlersType = Union[
    ListAdoptablesHandler, AdoptHandler, RenewHandler, UpdateTlsaHandler]


def main() -> int:
    'Main entry point.'
    parser = get_parser()
    args = parser.parse_args()
    executer: _HandlersType = args.func
    config = Configuration.parse(wrapper=args.config)
    return executer.init_and_process(args=args, config=config)
